/*	proxybang.c -- 02/10/22 IF
**				  	
**	 input bangs from different inlets, and outputs the inlet number
*/

#include "ext.h"			// Required for all Max external objects

void *this_class;			// Required. Global pointing to this class 
#define MAX 64		// max number of inlets

typedef struct _prox	// Data structure for this object
{
	t_object p_ob;		// Must always be the first field; used by Max
	void *p_proxy[MAX];  //
	short p_num;	// number of inlets
	long p_dummy;		// for proxy_new()
	long p_inlet;	// inlet number
	void *p_out;		// Pointer to outlet
} t_prox;

// Prototypes for methods: you need a method for each message you want to respond to
void *prox_new(long num);
void prox_free(t_prox *x);
void prox_bang(t_prox *x);	// Method for message "bang" in left inlet

int main(void)
{
	// set up our class: create a class definition 
	setup((t_messlist **) &this_class, (method)prox_new, (method)prox_free, (short)sizeof(t_prox), 0L,
         A_DEFLONG, nil);	
	addbang((method)prox_bang);
	return(0);
}


void *prox_new(long num)
{
	t_prox *prox;
    int i;

post("Argument: %d", num);    
	prox = (t_prox *)newobject(this_class);	// Create the new instance 
	if (num < 2)
		num = 2;
	if (num > MAX)
		num = MAX;
	prox->p_num = num; // total number of inlets (proxies)
    prox->p_out = intout(prox);	// Create outlet
    for (i = num - 1; i > 0; i--)
      prox->p_proxy[i] = proxy_new(prox, (long)i, &prox->p_dummy);
	return(prox);				// Must return a pointer to the new instance 
}

void prox_bang(t_prox *x)
{
    x->p_inlet = proxy_getinlet((t_object *)x);
post("bang: %d %d", x->p_dummy, x->p_inlet);
	outlet_int(x->p_out, x->p_inlet);
}

void prox_free(t_prox *x)
{
	short i;
	
	for (i = 1; i < x-> p_num; i++)
		freeobject(x->p_proxy[i]);
}

